/* TSShelfDragView.m created by tsengel on Sat 16-Aug-1997 */

#import "TSShelfDragView.h"
#import "TSShelfWindow.h"


@implementation TSShelfDragView

- (BOOL)acceptsFirstMouse:(NSEvent *)theEvent
{
    return YES;
}

- (void)mouseDown:(NSEvent *)theEvent
{
	NSPoint 	mouseLocation, curLocation, offset;
	BOOL		buttonDown;
	NSRect		theFrame;
	id			ourWindow;

	// Lets check what should happen to our window. The Alt key causes
	// it to switch tier's.

	ourWindow = [self window];
    theFrame = [ourWindow frame];

    if( [theEvent modifierFlags] & NSAlternateKeyMask )
    {
        [ourWindow dropToLowerLevel];
        // [ourWindow raiseToHigherLevel];
        return;
    }

    // Seems like it is more of a drag up and down action...so lets take care about that.

    mouseLocation = [theEvent locationInWindow];
    mouseLocation = [ourWindow convertBaseToScreen:mouseLocation];
    offset.y = theFrame.origin.y - mouseLocation.y;

    theEvent = [ourWindow nextEventMatchingMask:NSLeftMouseDraggedMask|NSLeftMouseUpMask];

    while( [theEvent type] != NSLeftMouseUp )
    {
        curLocation = [ourWindow mouseLocationOutsideOfEventStream];
        curLocation = [ourWindow convertBaseToScreen:curLocation];

        theFrame.origin.y = curLocation.y + offset.y;

        // Now check if the mouse button is really still down

        buttonDown = YES;

        if( buttonDown )
                [ourWindow setFrame:theFrame display:YES];
        else	break;

        theEvent = [ourWindow nextEventMatchingMask:NSLeftMouseDraggedMask|NSLeftMouseUpMask];
    }

/*
    oldMask = [ourWindow addToEventMask:NX_MOUSEDRAGGEDMASK];

			case NX_MOUSEDRAGGED:
				// Lets be sure that we have the location which coresponds 
				// to the windows current position. The events location data
				// can sometime be incorrect..because assigned while the 
				// window is moving..

				[ourWindow getMouseLocation:&curLocation];
				[ourWindow convertBaseToScreen:&curLocation];
				offset.y = mouseLocation.y - curLocation.y;

				// We missuse offset.x as the an old.y buffer.

				newy = theFrame.origin.y - offset.y;
				
				if( newy > 0 ) newy = 0;
 
				if(	newy < -(theFrame.size.height - 23) )
					newy = -(theFrame.size.height - 23);

				// Now put the window to the new position if the mouse is
				// really down
		
				buttonDown = YES;

				if( buttonDown )
						[ourWindow moveTo:0 :newy];
				else	looping = NO;

				NXPing();
		break;
		}		
   	} 
*/
}

@end
