/*************************************************************************
 * File Name: NSColor_MiscExtensions.h
 * Version  : 0.0 alpha
 * Date     : Thu 31-Aug-1997
 *************************************************************************
 *  COPYWHAT (C) 1997 by Tomi Engel
 *
 * This notice may not be removed from this source code.
 * The use and distribution of this software is governed by the
 * terms of the MiscKit license agreement.  Refer to the license
 * document included with the MiscKit distribution for the terms.
 *                    ALL RIGHTS RESERVED
 *
 *************************************************************************
 * Notes      :
 * Bugs       :
 * Author(s)  : tsengel
 * Last update: $Date: 1997/08/31 20:02:57 $
 * History    : $Log: NSColor_MiscExtensions.h,v $
 * History    : Revision 1.0  1997/08/31 20:02:57  tsengel
 * History    : Added to the MiscKit repository
 * History    :
 *************************************************************************/ 

#import <AppKit/AppKit.h>

@interface NSColor (MiscExtensions)

+ (NSColor *)colorWithCalibratedRgbaStringRepresentation:(NSString *)aString;
+ (NSColor *)colorWithDeviceRgbaStringRepresentation:(NSString *)aString;
- (NSString *)rgbaStringRepresentation;

@end
